## libsdl2 2.0.9+dfsg1

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)
project(SDL2 C)

# Global settings for all of the test targets
# FIXME: is this wrong?
remove_definitions(-DUSING_GENERATED_CONFIG_H)
link_libraries(SDL2_test SDL2-static)

# FIXME: Parent directory CMakeLists.txt only sets these for mingw/cygwin,
# but we need them for VS as well.
if(WINDOWS)
    link_libraries(SDL2main)
    add_definitions(-Dmain=SDL_main)
endif()

add_executable(checkkeys checkkeys.c)
add_executable(loopwave loopwave.c)
add_executable(loopwavequeue loopwavequeue.c)
add_executable(testresample testresample.c)
add_executable(testaudioinfo testaudioinfo.c)

file(GLOB TESTAUTOMATION_SOURCE_FILES testautomation*.c)
add_executable(testautomation ${TESTAUTOMATION_SOURCE_FILES})

add_executable(testmultiaudio testmultiaudio.c)
add_executable(testaudiohotplug testaudiohotplug.c)
add_executable(testaudiocapture testaudiocapture.c)
add_executable(testatomic testatomic.c)
add_executable(testintersections testintersections.c)
add_executable(testrelative testrelative.c)
add_executable(testhittesting testhittesting.c)
add_executable(testdraw2 testdraw2.c)
add_executable(testdrawchessboard testdrawchessboard.c)
add_executable(testdropfile testdropfile.c)
add_executable(testerror testerror.c)
add_executable(testfile testfile.c)
add_executable(testgamecontroller testgamecontroller.c)
add_executable(testgesture testgesture.c)
add_executable(testgl2 testgl2.c)
add_executable(testgles testgles.c)
add_executable(testgles2 testgles2.c)
add_executable(testhaptic testhaptic.c)
add_executable(testhotplug testhotplug.c)
add_executable(testrumble testrumble.c)
add_executable(testthread testthread.c)
add_executable(testiconv testiconv.c)
add_executable(testime testime.c)
add_executable(testjoystick testjoystick.c)
add_executable(testkeys testkeys.c)
add_executable(testloadso testloadso.c)
add_executable(testlock testlock.c)

if(APPLE)
    add_executable(testnative testnative.c
                              testnativecocoa.m
                              testnativex11.c)
elseif(WINDOWS)
    add_executable(testnative testnative.c testnativew32.c)
elseif(UNIX)
    add_executable(testnative testnative.c testnativex11.c)
endif()

add_executable(testoverlay2 testoverlay2.c testyuv_cvt.c)
add_executable(testplatform testplatform.c)
add_executable(testpower testpower.c)
add_executable(testfilesystem testfilesystem.c)
add_executable(testrendertarget testrendertarget.c)
add_executable(testscale testscale.c)
add_executable(testsem testsem.c)
add_executable(testshader testshader.c)
add_executable(testshape testshape.c)
add_executable(testsprite2 testsprite2.c)
add_executable(testspriteminimal testspriteminimal.c)
add_executable(teststreaming teststreaming.c)
add_executable(testtimer testtimer.c)
add_executable(testver testver.c)
add_executable(testviewport testviewport.c)
add_executable(testwm2 testwm2.c)
add_executable(testyuv testyuv.c testyuv_cvt.c)
add_executable(torturethread torturethread.c)
add_executable(testrendercopyex testrendercopyex.c)
add_executable(testmessage testmessage.c)
add_executable(testdisplayinfo testdisplayinfo.c)
add_executable(testqsort testqsort.c)
add_executable(testbounds testbounds.c)
add_executable(testcustomcursor testcustomcursor.c)
add_executable(controllermap controllermap.c)
add_executable(testvulkan testvulkan.c)

# HACK: Dummy target to cause the resource files to be copied to the build directory.
# Need to make it an executable so we can use the TARGET_FILE_DIR generator expression.
# This is needed so they get copied to the correct Debug/Release subdirectory in Xcode.
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/resources_dummy.c "int main(int argc, const char **argv){ return 1; }\n")
add_executable(SDL2_test_resoureces ${CMAKE_CURRENT_BINARY_DIR}/resources_dummy.c)

file(GLOB RESOURCE_FILES *.bmp *.wav)
foreach(RESOURCE_FILE ${RESOURCE_FILES})
    add_custom_command(TARGET SDL2_test_resoureces POST_BUILD COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different ${RESOURCE_FILE} $<TARGET_FILE_DIR:SDL2_test_resoureces>)
endforeach(RESOURCE_FILE)

file(COPY ${RESOURCE_FILES} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# TODO: Might be easier to make all targets depend on the resources...?
add_dependencies(testscale SDL2_test_resoureces)
add_dependencies(testrendercopyex SDL2_test_resoureces)
add_dependencies(controllermap SDL2_test_resoureces)
add_dependencies(testyuv SDL2_test_resoureces)
add_dependencies(testgamecontroller SDL2_test_resoureces)
add_dependencies(testshape SDL2_test_resoureces)
add_dependencies(testshader SDL2_test_resoureces)
add_dependencies(testnative SDL2_test_resoureces)
add_dependencies(testspriteminimal SDL2_test_resoureces)
add_dependencies(testautomation SDL2_test_resoureces)
add_dependencies(testcustomcursor SDL2_test_resoureces)
add_dependencies(testrendertarget SDL2_test_resoureces)
add_dependencies(testsprite2 SDL2_test_resoureces)

add_dependencies(loopwave SDL2_test_resoureces)
add_dependencies(loopwavequeue SDL2_test_resoureces)
add_dependencies(testresample SDL2_test_resoureces)
add_dependencies(testaudiohotplug SDL2_test_resoureces)
add_dependencies(testmultiaudio SDL2_test_resoureces)

=== debian/changelog ===
libsdl2 (2.0.9+dfsg1-1ubuntu1.19.04.1) disco-security; urgency=medium

  * SECURITY UPDATE: heap-based buffer over-read in Blit1to4
    - debian/patches/CVE-2019-7635.diff: add error checking to SDL_LoadBMP_RW
    - CVE-2019-7635
  * SECURITY UPDATE: heap-based buffer over-read in Map1toN and
     SDL_GetRGB
    - debian/patches/CVE-2019-7636_CVE-2019-7638.patch: add error checking to 
      SDL_LoadBMP_RW
    - CVE-2019-7636
    - CVE-2019-7638

 -- Avital Ostromich <avital.ostromich@canonical.com>  Wed, 28 Aug 2019 14:05:49 -0400

libsdl2 (2.0.9+dfsg1-1ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build-depend on libmirclient-dev
    - Explicitly enable --enable-video-mir in rules

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Feb 2019 11:26:19 +0100

libsdl2 (2.0.9+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #914251)
  * Drop SDL2-dynapi-symbol-resolution-fix.patch, applied upstream.
  * Refresh fix-cross-building-907711.patch
  * Bump SHLIBVER to 2.0.9.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 02 Feb 2019 17:13:17 +0100

libsdl2 (2.0.8+dfsg1-6ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Build-depend on libmirclient-dev
    - Explicitly enable --enable-video-mir in rules

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Oct 2018 19:08:46 +0100

libsdl2 (2.0.8+dfsg1-6) unstable; urgency=medium

  * d/rules: Add @ in 'tar --mtime="@$(SOURCE_DATE_EPOCH)"', otherwise the
    date is not valid

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Thu, 25 Oct 2018 01:42:18 +0200

libsdl2 (2.0.8+dfsg1-5) unstable; urgency=medium

  * Bump Policy Standards-Version to 4.2.1 (no changes needed)
  * d/rules: include /usr/share/dpkg/architecture.mk and .../pkg-info.mk
    to provide DEB_HOST_ARCH_CPU, DEB_HOST_MULTIARCH and
    SOURCE_DATE_EPOCH, instead of getting them through shell invocations.
  * d/watch: Switch to version=4
  * Switch to debhelper compat level v11
    - Force examples to be installed in libsdl2-doc
  * d/patches:
    - add fix-cross-building-907711.patch to fix cross-building by using
      the right pkg-config depending on the architecture (Closes: #907711)
      Thanks Helmut Grohne for the report and the patch.

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 20 Oct 2018 12:51:58 +0200

=== debian/control ===
Source: libsdl2
Priority: optional
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Sam Hocevar <sho@debian.org>,
 Manuel A. Fernandez Montecelo <mafm@debian.org>,
 Felix Geyer <fgeyer@debian.org>
Standards-Version: 4.2.1
Build-Depends:
 debhelper (>= 11~),
 fcitx-libs-dev,
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libegl1-mesa-dev [!hurd-any],
 libgl1-mesa-dev,
 libgles2-mesa-dev [!hurd-any],
 libglu1-mesa-dev,
 libibus-1.0-dev,
 libmirclient-dev,
 libpulse-dev,
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libvulkan-dev [linux-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 pkg-config,
 libsamplerate0-dev,
 wayland-protocols
Build-Depends-Indep:
 doxygen
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2.git
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2
Homepage: https://www.libsdl.org/

Package: libsdl2-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 libsdl-1.3-0
Replaces:
 libsdl-1.3-0
Description: Simple DirectMedia Layer
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This version of SDL is compiled with X11 and Wayland graphics drivers and OSS,
 ALSA, sndio and PulseAudio sound drivers.

Package: libsdl2-dev
Section: libdevel
Architecture: any
Depends:
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libegl1-mesa-dev [!hurd-any],
 libgl1-mesa-dev,
 libgles2-mesa-dev [!hurd-any],
 libglu1-mesa-dev,
 libibus-1.0-dev,
 libmirclient-dev,
 libpulse-dev,
 libsdl2-2.0-0 (= ${binary:Version}),
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 ${misc:Depends}
Conflicts:
 libsdl-1.3-dev
Replaces:
 libsdl-1.3-dev
Description: Simple DirectMedia Layer development files
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libjs-jquery
Breaks:
 libsdl2-dev (<< 2.0.4+dfsg-1)
Replaces:
 libsdl2-dev (<< 2.0.4+dfsg-1)
Description: Reference manual for libsdl2
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the reference manual and examples.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

SHLIBVER = 2.0.9

confflags = --disable-rpath --enable-sdl-dlopen \
            --disable-nas --disable-esd --disable-arts \
            --disable-alsa-shared --disable-pulseaudio-shared \
            --enable-ibus \
            --enable-video-mir \
            --disable-x11-shared --disable-video-directfb \
            --enable-video-opengles \
            --enable-video-wayland --disable-wayland-shared

# disable autoheader (invoked automatically by autoreconf), necessary in order
# to use debhelper compat level v10 without overriding dh-autoreconf calls
export AUTOHEADER := /bin/true


ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
  confflags += --disable-altivec
endif

ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
  confflags += --disable-altivec
endif

# disable Wayland and Vulkan on non-Linux, they do not support other kernels at the moment
ifeq (hurd,$(findstring hurd,$(DEB_HOST_ARCH_CPU)))
  confflags += --disable-video-vulkan
  confflags += --disable-video-wayland
endif
ifeq (kfreefsd,$(findstring kfreebsd,$(DEB_HOST_ARCH_CPU)))
  confflags += --disable-video-vulkan
  confflags += --disable-video-wayland
endif

# disable OpenGLES on Hurd, it does not support it at the moment
ifeq (hurd,$(findstring hurd,$(DEB_HOST_ARCH_CPU)))
  confflags += --disable--video-opengles
endif


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

override_dh_auto_build-indep:
	GZIP="-9n" tar czf debian/examples.tar.gz test --owner=0 --group=0 --mode=go=rX,u+rw,a-s --clamp-mtime --mtime="@$(SOURCE_DATE_EPOCH)" --sort=name
	doxygen docs/doxyfile
	# useless files
	find output -name "*.md5" -delete
	find output -type d -empty -delete

	find output -name "jquery.js" -delete
	dh_link -plibsdl2-doc usr/share/javascript/jquery/jquery.js usr/share/doc/libsdl2-doc/html/jquery.js

# Force examples to be installed in libsdl2-doc, it does not happen with compat
# level v11 despite having the file debian/libsdl2-doc.examples (it gets
# installed as part of libsdl2-dev instead)
override_dh_installexamples-indep:
	dh_installexamples -i --doc-main-package=libsdl2-doc

override_dh_auto_build-arch:
	dh_auto_build -- V=1

override_dh_auto_clean-indep:
	dh_auto_clean
	rm -f debian/examples.tar.gz
	rm -rf output

override_dh_missing:
	dh_missing --fail-missing -XlibSDL2.la -XlibSDL2main.la -XlibSDL2_test.la

override_dh_link:
	# to address lintian warning
	# W: libsdl2-2.0-0: dev-pkg-without-shlib-symlink usr/lib/x86_64-linux-gnu/libSDL2-2.0.so.0.0.0 usr/lib/x86_64-linux-gnu/libSDL2-2.0.so
	dh_link -plibsdl2-dev usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2-2.0.so.0 usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2-2.0.so
	dh_link --remaining-packages

override_dh_makeshlibs:
	dh_makeshlibs -V"libsdl2-2.0-0 (>= $(SHLIBVER))"

override_dh_strip:
	dh_strip --dbgsym-migration='libsdl2-dbg (<< 2.0.4+dfsg2-1~)'

override_dh_installchangelogs:
	dh_installchangelogs -- WhatsNew.txt

## libsdl2 2.0.9.4

=== CMakeLists.txt ===
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "Prevented in-tree built. Please create a build directory outside of the SDL source code and call cmake from there")
endif()

cmake_minimum_required(VERSION 2.8.11)
project(SDL2 C)

# !!! FIXME: this should probably do "MACOSX_RPATH ON" as a target property
# !!! FIXME:  for the SDL2 shared library (so you get an
# !!! FIXME:  install_name ("soname") of "@rpath/libSDL-whatever.dylib"
# !!! FIXME:  instead of "/usr/local/lib/libSDL-whatever.dylib"), but I'm
# !!! FIXME:  punting for now and leaving the existing behavior. Until this
# !!! FIXME:  properly resolved, this line silences a warning in CMake 3.0+.
# !!! FIXME:  remove it and this comment entirely once the problem is
# !!! FIXME:  properly resolved.
#cmake_policy(SET CMP0042 OLD)

include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CheckTypeSize)
include(CheckStructHasMember)
include(CMakeDependentOption)
include(FindPkgConfig)
include(GNUInstallDirs)
set(CMAKE_MODULE_PATH "${SDL2_SOURCE_DIR}/cmake")
include(${SDL2_SOURCE_DIR}/cmake/macros.cmake)
include(${SDL2_SOURCE_DIR}/cmake/sdlchecks.cmake)

# General settings
# Edit include/SDL_version.h and change the version, then:
#   SDL_MICRO_VERSION += 1;
#   SDL_INTERFACE_AGE += 1;
#   SDL_BINARY_AGE += 1;
# if any functions have been added, set SDL_INTERFACE_AGE to 0.
# if backwards compatibility has been broken,
# set SDL_BINARY_AGE and SDL_INTERFACE_AGE to 0.
set(SDL_MAJOR_VERSION 2)
set(SDL_MINOR_VERSION 0)
set(SDL_MICRO_VERSION 9)
set(SDL_INTERFACE_AGE 0)
set(SDL_BINARY_AGE 9)
set(SDL_VERSION "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}.${SDL_MICRO_VERSION}")
# the following should match the versions in Xcode project file:
set(DYLIB_CURRENT_VERSION 10.0.0)
set(DYLIB_COMPATIBILITY_VERSION 1.0.0)

# Set defaults preventing destination file conflicts
set(SDL_CMAKE_DEBUG_POSTFIX "d"
    CACHE STRING "Name suffix for debug builds")

mark_as_advanced(CMAKE_IMPORT_LIBRARY_SUFFIX SDL_CMAKE_DEBUG_POSTFIX)

# Calculate a libtool-like version number
math(EXPR LT_CURRENT "${SDL_MICRO_VERSION} - ${SDL_INTERFACE_AGE}")
math(EXPR LT_AGE "${SDL_BINARY_AGE} - ${SDL_INTERFACE_AGE}")
math(EXPR LT_MAJOR "${LT_CURRENT}- ${LT_AGE}")
set(LT_REVISION "${SDL_INTERFACE_AGE}")
set(LT_RELEASE "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}")
set(LT_VERSION "${LT_MAJOR}.${LT_AGE}.${LT_REVISION}")

message(STATUS "${LT_VERSION} :: ${LT_AGE} :: ${LT_REVISION} :: ${LT_CURRENT} :: ${LT_RELEASE}")

# General settings & flags
set(LIBRARY_OUTPUT_DIRECTORY "build")
# Check for 64 or 32 bit
set(SIZEOF_VOIDP ${CMAKE_SIZEOF_VOID_P})
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ARCH_64 TRUE)
  set(PROCESSOR_ARCH "x64")
else()
  set(ARCH_64 FALSE)
  set(PROCESSOR_ARCH "x86")
endif()
set(LIBNAME SDL2)
if(NOT LIBTYPE)
  set(LIBTYPE SHARED)
endif()

# Get the platform
if(WIN32)
  if(NOT WINDOWS)
    set(WINDOWS TRUE)
  endif()
elseif(UNIX AND NOT APPLE)
  if(CMAKE_SYSTEM_NAME MATCHES ".*Linux")
    set(LINUX TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "kFreeBSD.*")
    set(FREEBSD TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
    set(NETBSD TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
    set(OPENBSD TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES ".*GNU.*")
    set(GNU TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES ".*BSDI.*")
    set(BSDI TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "DragonFly.*|FreeBSD")
    set(FREEBSD TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "SYSV5.*")
    set(SYSV5 TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "Solaris.*")
    set(SOLARIS TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "HP-UX.*")
    set(HPUX TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "AIX.*")
    set(AIX TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES "Minix.*")
    set(MINIX TRUE)
  endif()
elseif(APPLE)
  if(CMAKE_SYSTEM_NAME MATCHES ".*Darwin.*")
    set(DARWIN TRUE)
  elseif(CMAKE_SYSTEM_NAME MATCHES ".*MacOS.*")
    set(MACOSX TRUE)
  endif()
  # TODO: iOS?
elseif(CMAKE_SYSTEM_NAME MATCHES "BeOS.*")
  message_error("BeOS support has been removed as of SDL 2.0.2.")
elseif(CMAKE_SYSTEM_NAME MATCHES "Haiku.*")
  set(HAIKU TRUE)
endif()

# Don't mistake osx for unix
if(UNIX AND NOT APPLE)
  set(UNIX_SYS ON)
else()
  set(UNIX_SYS OFF)
endif()

if(UNIX OR APPLE)
  set(UNIX_OR_MAC_SYS ON)
else()
  set(UNIX_OR_MAC_SYS OFF)
endif()

if (UNIX_OR_MAC_SYS AND NOT EMSCRIPTEN) # JavaScript does not yet have threading support, so disable pthreads when building for Emscripten.
  set(SDL_PTHREADS_ENABLED_BY_DEFAULT ON)
else()
  set(SDL_PTHREADS_ENABLED_BY_DEFAULT OFF)
endif()

# Default option knobs
if(APPLE OR ARCH_64)
  if(NOT "${CMAKE_OSX_ARCHITECTURES}" MATCHES "arm")
    set(OPT_DEF_SSEMATH ON)
  endif()
endif()
if(UNIX OR MINGW OR MSYS)
  set(OPT_DEF_LIBC ON)
endif()

# Compiler info
if(CMAKE_COMPILER_IS_GNUCC)
  set(USE_GCC TRUE)
  set(OPT_DEF_ASM TRUE)
elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(USE_CLANG TRUE)
  set(OPT_DEF_ASM TRUE)
elseif(MSVC_VERSION GREATER 1400) # VisualStudio 8.0+
  set(OPT_DEF_ASM TRUE)
  #set(CMAKE_C_FLAGS "/ZI /WX- /
else()
  set(OPT_DEF_ASM FALSE)
endif()

if(USE_GCC OR USE_CLANG)
  set(OPT_DEF_GCC_ATOMICS ON)
endif()

# Default flags, if not set otherwise
if("$ENV{CFLAGS}" STREQUAL "")
  if(CMAKE_BUILD_TYPE STREQUAL "")
    if(USE_GCC OR USE_CLANG)
      set(CMAKE_C_FLAGS "-g -O3")
    endif()
  endif()
else()
  set(CMAKE_C_FLAGS "$ENV{CFLAGS}")
  list(APPEND EXTRA_CFLAGS "$ENV{CFLAGS}")
endif()
if(NOT ("$ENV{CFLAGS}" STREQUAL "")) # Hackish, but does the trick on Win32
  list(APPEND EXTRA_LDFLAGS "$ENV{LDFLAGS}")
endif()

if(MSVC)
  option(FORCE_STATIC_VCRT "Force /MT for static VC runtimes" OFF)
  if(FORCE_STATIC_VCRT)
    foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
    endforeach()
  endif()

  # Make sure /RTC1 is disabled, otherwise it will use functions from the CRT
  foreach(flag_var
      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
    string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
  endforeach(flag_var)
endif()

# Those are used for pkg-config and friends, so that the SDL2.pc, sdl2-config,
# etc. are created correctly.
set(SDL_LIBS "-lSDL2")
set(SDL_CFLAGS "")

# When building shared lib for Windows with MinGW,
# avoid the DLL having a "lib" prefix
if(WINDOWS)
  set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

# Emscripten toolchain has a nonempty default value for this, and the checks
# in this file need to change that, so remember the original value, and
# restore back to that afterwards. For check_function_exists() to work in
# Emscripten, this value must be at its default value.
set(ORIG_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})

if(CYGWIN)
  # We build SDL on cygwin without the UNIX emulation layer
  include_directories("-I/usr/include/mingw")
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -mno-cygwin")
  check_c_source_compiles("int main(int argc, char **argv) {}"
    HAVE_GCC_NO_CYGWIN)
  set(CMAKE_REQUIRED_FLAGS ${ORIG_CMAKE_REQUIRED_FLAGS})
  if(HAVE_GCC_NO_CYGWIN)
    list(APPEND EXTRA_LDFLAGS "-mno-cygwin")
    list(APPEND SDL_LIBS "-mno-cygwin")
  endif()
  set(SDL_CFLAGS "${SDL_CFLAGS} -I/usr/include/mingw")
endif()

add_definitions(-DUSING_GENERATED_CONFIG_H)
# General includes
include_directories(${SDL2_BINARY_DIR}/include ${SDL2_SOURCE_DIR}/include)
if(USE_GCC OR USE_CLANG)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -idirafter ${SDL2_SOURCE_DIR}/src/video/khronos")
else()
  include_directories(${SDL2_SOURCE_DIR}/src/video/khronos)
endif()

# All these ENABLED_BY_DEFAULT vars will default to ON if not specified, so
#  you only need to have a platform override them if they are disabling.
set(OPT_DEF_ASM TRUE)
if(EMSCRIPTEN)
  # Set up default values for the currently supported set of subsystems:
  # Emscripten/Javascript does not have assembly support, a dynamic library
  # loading architecture, low-level CPU inspection or multithreading.
  set(OPT_DEF_ASM FALSE)
  set(SDL_SHARED_ENABLED_BY_DEFAULT OFF)
  set(SDL_ATOMIC_ENABLED_BY_DEFAULT OFF)
  set(SDL_THREADS_ENABLED_BY_DEFAULT OFF)
  set(SDL_LOADSO_ENABLED_BY_DEFAULT OFF)
  set(SDL_CPUINFO_ENABLED_BY_DEFAULT OFF)
  set(SDL_DLOPEN_ENABLED_BY_DEFAULT OFF)
endif()

if (NOT DEFINED SDL_SHARED_ENABLED_BY_DEFAULT)
    set(SDL_SHARED_ENABLED_BY_DEFAULT ON)
endif()

set(SDL_SUBSYSTEMS
    Atomic Audio Video Render Events Joystick Haptic Power Threads Timers
    File Loadso CPUinfo Filesystem Dlopen Sensor)
foreach(_SUB ${SDL_SUBSYSTEMS})
  string(TOUPPER ${_SUB} _OPT)
  if (NOT DEFINED SDL_${_OPT}_ENABLED_BY_DEFAULT)
    set(SDL_${_OPT}_ENABLED_BY_DEFAULT ON)
  endif()
  option(SDL_${_OPT} "Enable the ${_SUB} subsystem" ${SDL_${_OPT}_ENABLED_BY_DEFAULT})
endforeach()

option_string(ASSERTIONS "Enable internal sanity checks (auto/disabled/release/enabled/paranoid)" "auto")
#set_option(DEPENDENCY_TRACKING "Use gcc -MMD -MT dependency tracking" ON)
set_option(LIBC                "Use the system C library" ${OPT_DEF_LIBC})
set_option(GCC_ATOMICS         "Use gcc builtin atomics" ${OPT_DEF_GCC_ATOMICS})
set_option(ASSEMBLY            "Enable assembly routines" ${OPT_DEF_ASM})
set_option(SSEMATH             "Allow GCC to use SSE floating point math" ${OPT_DEF_SSEMATH})
set_option(MMX                 "Use MMX assembly routines" ${OPT_DEF_ASM})
set_option(3DNOW               "Use 3Dnow! MMX assembly routines" ${OPT_DEF_ASM})
set_option(SSE                 "Use SSE assembly routines" ${OPT_DEF_ASM})
set_option(SSE2                "Use SSE2 assembly routines" ${OPT_DEF_SSEMATH})
set_option(SSE3                "Use SSE3 assembly routines" ${OPT_DEF_SSEMATH})
set_option(ALTIVEC             "Use Altivec assembly routines" ${OPT_DEF_ASM})
set_option(DISKAUDIO           "Support the disk writer audio driver" ON)
set_option(DUMMYAUDIO          "Support the dummy audio driver" ON)
set_option(VIDEO_DIRECTFB      "Use DirectFB video driver" OFF)
dep_option(DIRECTFB_SHARED     "Dynamically load directfb support" ON "VIDEO_DIRECTFB" OFF)
set_option(VIDEO_DUMMY         "Use dummy video driver" ON)
set_option(VIDEO_OPENGL        "Include OpenGL support" ON)
set_option(VIDEO_OPENGLES      "Include OpenGL ES support" ON)
set_option(PTHREADS            "Use POSIX threads for multi-threading" ${SDL_PTHREADS_ENABLED_BY_DEFAULT})
dep_option(PTHREADS_SEM        "Use pthread semaphores" ON "PTHREADS" OFF)
set_option(SDL_DLOPEN          "Use dlopen for shared object loading" ${SDL_DLOPEN_ENABLED_BY_DEFAULT})
set_option(OSS                 "Support the OSS audio API" ${UNIX_SYS})
set_option(ALSA                "Support the ALSA audio API" ${UNIX_SYS})
dep_option(ALSA_SHARED         "Dynamically load ALSA audio support" ON "ALSA" OFF)
set_option(JACK                "Support the JACK audio API" ${UNIX_SYS})
dep_option(JACK_SHARED         "Dynamically load JACK audio support" ON "JACK" OFF)
set_option(ESD                 "Support the Enlightened Sound Daemon" ${UNIX_SYS})
dep_option(ESD_SHARED          "Dynamically load ESD audio support" ON "ESD" OFF)
set_option(PULSEAUDIO          "Use PulseAudio" ${UNIX_SYS})
dep_option(PULSEAUDIO_SHARED   "Dynamically load PulseAudio support" ON "PULSEAUDIO" OFF)
set_option(ARTS                "Support the Analog Real Time Synthesizer" ${UNIX_SYS})
dep_option(ARTS_SHARED         "Dynamically load aRts audio support" ON "ARTS" OFF)
set_option(NAS                 "Support the NAS audio API" ${UNIX_SYS})
set_option(NAS_SHARED          "Dynamically load NAS audio API" ${UNIX_SYS})
set_option(SNDIO               "Support the sndio audio API" ${UNIX_SYS})

=== debian/changelog ===
libsdl2 (2.0.9.4-1+eagle) unstable; urgency=medium

  * update

 -- Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>  Tue, 09 Feb 2021 12:36:45 +0800

libsdl2 (2.0.9.3-1+dde) unstable; urgency=medium

  * add deepin-stream-write-error.patch
  * sdl向pulseaudio写入数据错误时打印日志，客户端可捕获该异常关闭设备并清空资源

 -- Huang Jie <huangjie@uniontech.com>  Thu, 21 Jan 2021 19:30:31 +0800

libsdl2 (2.0.9.1-1+dde) unstable; urgency=medium

  * add SDL_fix_Chinese_input.patch
  * add SDL_fix_clipboard_crash_issuse.patch
  * add SDL_fix_Restore.patch
  * 针对安卓模拟器进行的修改，主要是与输入法、最小化显示有关

 -- Hu Feng <hufeng@uniontech.com>  Wed, 23 Sep 2020 16:29:39 +0800

=== debian/tests/control ===
Tests: build
Depends: libsdl2-dev, build-essential
Restrictions: allow-stderr

Tests: build-all
Depends: @builddeps@, libsdl2-dev, cmake, build-essential
Restrictions: allow-stderr

## libsdl2 2.0.10%2Bdfsg1

=== debian/changelog ===
libsdl2 (2.0.10+dfsg1-2~mx19+1) mx; urgency=medium

  * Repackage upstream release for MX 19.

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Sat, 15 Feb 2020 16:44:38 -0500

libsdl2 (2.0.10+dfsg1-2) unstable; urgency=medium

  [ Simon McVittie ]
  * d/tests: Add a test that detecting SDL2 via CMake does not regress.
    This is the sort of thing that could easily regress while solving #909740.
  * Install all headers in an architecture-specific location.
    This approach was suggested by Adrian Bunk on #909740, as one of several
    possible ways to avoid SDL_config.h colliding between architectures.
    Because this approach uses a different @includedir@ for each architecture,
    we can no longer have @includedir@ in sdl2-config.in: that would result
    in non-co-installability. However, simply removing it (similar to
    no-libdir.patch) is not an option, because the SDL 2 headers are not
    on the default include path (and they cannot be added to it without
    breaking parallel-installability of SDL 1.2 or a hypothetical future
    SDL 3). Instead, patch sdl-config.in to ask pkg-config for its CFLAGS
    and LIBS. This can supersede the previous no-libdir.patch.
    This relies on the assumption that cross-compilation will always set
    PKG_CONFIG, even if that environment variable is not otherwise used by
    the build system that is invoking sdl2-config.
    The sdl2-config.cmake.in part of no-libdir.patch can simply be dropped,
    because that file is installed to an architecture-specific location
    anyway, namely ${libdir}/cmake.
  * Mark libsdl2-dev as Multi-Arch: same (Closes: #909740)

  [ Gianfranco Costamagna ]
  * Upload part of Ubuntu delta to Debian

  [ Timo Aaltonen ]
  * rules: Disable GLES1, it's getting enabled because libgles-dev ships
    GLES1 headers now, but they have conflicting types against the ones
    SDL has.

  [ Steve Langasek ]
  * Make autopkgtests cross-test-friendly. (Closes: #946496)

  [ Felix Geyer ]
  * Drop build-all autopkgtest.
    - We already have tests that check if building against SDL2 with pkg-config,
      sdl2-config and cmake works correctly.
    - It has a large overhead as it rebuilds SDL2 and requires supporting
      cmake as a second buildsystem.
  * Add the non-multiarch include dir to pkg-config cflags for compatibility.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 02 Feb 2020 23:02:25 +0100

libsdl2 (2.0.10+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #939249)
    - Fixes warnings with -Wundef on non-x86 hosts. (Closes: #892087)
    - Fixes CVE-2019-7572, CVE-2019-7573, CVE-2019-7574, CVE-2019-7575,
      CVE-2019-7576, CVE-2019-7577, CVE-2019-7578, CVE-2019-7635,
      CVE-2019-7636, CVE-2019-7638 and CVE-2019-13626 (Closes: #924610)
  * Drop fix-cross-building-907711.patch, fixed upstream.
  * Bump SHLIBVER to 2.0.10.
  * Add support for nodoc build-profile.
  * Switch to debhelper compat level 12.
  * Cherry-pick upstream fix for CVE-2019-13616.
  * Mark autopkgtests as superficial.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 19 Sep 2019 23:50:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,11 @@
 Source: libsdl2
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
 XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
-Uploaders:
- Sam Hocevar <sho@debian.org>,
- Manuel A. Fernandez Montecelo <mafm@debian.org>,
- Felix Geyer <fgeyer@debian.org>
 Standards-Version: 4.2.1
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 12),
  fcitx-libs-dev,
  libasound2-dev [linux-any],
  libdbus-1-dev,
@@ -18,7 +14,6 @@
  libgles2-mesa-dev [!hurd-any],
  libglu1-mesa-dev,
  libibus-1.0-dev,
- libmirclient-dev,
  libpulse-dev,
  libsndio-dev,
  libudev-dev [linux-any],
@@ -41,7 +36,7 @@
  libsamplerate0-dev,
  wayland-protocols
 Build-Depends-Indep:
- doxygen
+ doxygen <!nodoc>
 Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2.git
 Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2
 Homepage: https://www.libsdl.org/
@@ -68,6 +63,7 @@
 Package: libsdl2-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends:
  libasound2-dev [linux-any],
  libdbus-1-dev,
@@ -76,7 +72,6 @@
  libgles2-mesa-dev [!hurd-any],
  libglu1-mesa-dev,
  libibus-1.0-dev,
- libmirclient-dev,
  libpulse-dev,
  libsdl2-2.0-0 (= ${binary:Version}),
  libsndio-dev,
@@ -95,6 +90,7 @@
  libxt-dev,
  libxv-dev,
  libxxf86vm-dev,
+ pkg-config,
  ${misc:Depends}
 Conflicts:
  libsdl-1.3-dev
@@ -111,6 +107,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
+Build-Profiles: <!nodoc>
 Depends:
  ${misc:Depends},
  libjs-jquery

=== debian/tests/control ===
Tests: build
Depends: libsdl2-dev, build-essential
Restrictions: superficial, allow-stderr

Tests: cmake
Depends: build-essential, cmake, libsdl2-dev
Restrictions: superficial, allow-stderr

Tests: related-library
Depends: build-essential, libsdl2-dev, libsdl2-ttf-dev
Restrictions: superficial, allow-stderr

## libsdl2 2.0.10+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 endif()
 
 cmake_minimum_required(VERSION 2.8.11)
-project(SDL2 C)
+project(SDL2 C CXX)
 
 # !!! FIXME: this should probably do "MACOSX_RPATH ON" as a target property
 # !!! FIXME:  for the SDL2 shared library (so you get an
@@ -42,9 +42,9 @@
 # set SDL_BINARY_AGE and SDL_INTERFACE_AGE to 0.
 set(SDL_MAJOR_VERSION 2)
 set(SDL_MINOR_VERSION 0)
-set(SDL_MICRO_VERSION 9)
+set(SDL_MICRO_VERSION 10)
 set(SDL_INTERFACE_AGE 0)
-set(SDL_BINARY_AGE 9)
+set(SDL_BINARY_AGE 10)
 set(SDL_VERSION "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}.${SDL_MICRO_VERSION}")
 # the following should match the versions in Xcode project file:
 set(DYLIB_CURRENT_VERSION 10.0.0)
@@ -64,7 +64,7 @@
 set(LT_RELEASE "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}")
 set(LT_VERSION "${LT_MAJOR}.${LT_AGE}.${LT_REVISION}")
 
-message(STATUS "${LT_VERSION} :: ${LT_AGE} :: ${LT_REVISION} :: ${LT_CURRENT} :: ${LT_RELEASE}")
+#message(STATUS "${LT_VERSION} :: ${LT_AGE} :: ${LT_REVISION} :: ${LT_CURRENT} :: ${LT_RELEASE}")
 
 # General settings & flags
 set(LIBRARY_OUTPUT_DIRECTORY "build")
@@ -155,6 +155,20 @@
   set(OPT_DEF_LIBC ON)
 endif()
 
+# The hidraw support doesn't catch Xbox, PS4 and Nintendo controllers,
+#  so we'll just use libusb when it's available. Except that libusb
+#  requires root permissions to open devices, so that's not generally
+#  useful, and we'll disable this by default on Unix. Windows and macOS
+#  can use it without root access, though, so enable by default there.
+if(WINDOWS OR APPLE OR ANDROID)
+  set(HIDAPI_SKIP_LIBUSB TRUE)
+else()
+  set(HIDAPI_SKIP_LIBUSB FALSE)
+endif()
+if (HIDAPI_SKIP_LIBUSB)
+  set(OPT_DEF_HIDAPI ON)
+endif()
+
 # Compiler info
 if(CMAKE_COMPILER_IS_GNUCC)
   set(USE_GCC TRUE)
@@ -264,8 +278,23 @@
   set(SDL_DLOPEN_ENABLED_BY_DEFAULT OFF)
 endif()
 
+# When defined, respect CMake's BUILD_SHARED_LIBS setting:
+set(SDL_STATIC_ENABLED_BY_DEFAULT ON)
 if (NOT DEFINED SDL_SHARED_ENABLED_BY_DEFAULT)
+  # ...unless decided already (as for EMSCRIPTEN)
+
+  set(SDL_SHARED_ENABLED_BY_DEFAULT OFF)
+
+  if (NOT DEFINED BUILD_SHARED_LIBS)
+    # No preference? Build both, just like the AC/AM configure
     set(SDL_SHARED_ENABLED_BY_DEFAULT ON)
+
+  elseif (BUILD_SHARED_LIBS)
+    # In this case, we assume the user wants a shared lib and don't build
+    # the static one
+    set(SDL_SHARED_ENABLED_BY_DEFAULT ON)
+    set(SDL_STATIC_ENABLED_BY_DEFAULT OFF)
+  endif()
 endif()
 
 set(SDL_SUBSYSTEMS
@@ -302,16 +331,3 @@
 dep_option(PTHREADS_SEM        "Use pthread semaphores" ON "PTHREADS" OFF)
 set_option(SDL_DLOPEN          "Use dlopen for shared object loading" ${SDL_DLOPEN_ENABLED_BY_DEFAULT})
 set_option(OSS                 "Support the OSS audio API" ${UNIX_SYS})
-set_option(ALSA                "Support the ALSA audio API" ${UNIX_SYS})
-dep_option(ALSA_SHARED         "Dynamically load ALSA audio support" ON "ALSA" OFF)
-set_option(JACK                "Support the JACK audio API" ${UNIX_SYS})
-dep_option(JACK_SHARED         "Dynamically load JACK audio support" ON "JACK" OFF)
-set_option(ESD                 "Support the Enlightened Sound Daemon" ${UNIX_SYS})
-dep_option(ESD_SHARED          "Dynamically load ESD audio support" ON "ESD" OFF)
-set_option(PULSEAUDIO          "Use PulseAudio" ${UNIX_SYS})
-dep_option(PULSEAUDIO_SHARED   "Dynamically load PulseAudio support" ON "PULSEAUDIO" OFF)
-set_option(ARTS                "Support the Analog Real Time Synthesizer" ${UNIX_SYS})
-dep_option(ARTS_SHARED         "Dynamically load aRts audio support" ON "ARTS" OFF)
-set_option(NAS                 "Support the NAS audio API" ${UNIX_SYS})
-set_option(NAS_SHARED          "Dynamically load NAS audio API" ${UNIX_SYS})
-set_option(SNDIO               "Support the sndio audio API" ${UNIX_SYS})

=== debian/changelog ===
libsdl2 (2.0.10+dfsg1-3) unstable; urgency=medium

  * Team upload

  [ Gianfranco Costamagna ]
  * Fix autopkgtests for cross-architecture testing, by making sure
    sdl2-config calls the correct pkg-config command

  [ Simon McVittie ]
  * Revert "Add the non-multiarch include dir to pkg-config cflags for
    compatibility."
  * Revert "Install all headers in an architecture-specific location"
  * Make SDL_config.h redirect to an architecture-specific version
    (Closes: #909740, #951087, #951943, #951959, #951974, #951976, #952049,
    #951962, #952105, #955416)
  * Create a SDL_platform.h symlink in /usr/include/MULTIARCH/SDL2
    (Closes: #952046, #952066, #952098)
  * Add autopkgtests for various deprecated use patterns

 -- Simon McVittie <smcv@debian.org>  Mon, 13 Apr 2020 18:27:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,11 @@
 Source: libsdl2
 Priority: optional
 Section: libs
-Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
-XSBC-Original-Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
+Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Sam Hocevar <sho@debian.org>,
+ Manuel A. Fernandez Montecelo <mafm@debian.org>,
+ Felix Geyer <fgeyer@debian.org>
 Standards-Version: 4.2.1
 Build-Depends:
  debhelper-compat (= 12),
@@ -90,7 +93,6 @@
  libxt-dev,
  libxv-dev,
  libxxf86vm-dev,
- pkg-config,
  ${misc:Depends}
 Conflicts:
  libsdl-1.3-dev

=== debian/tests/control ===
Tests: build
Depends: build-essential, libsdl2-dev
Restrictions: superficial, allow-stderr

Tests: cmake
Depends: build-essential, cmake, libsdl2-dev
Restrictions: superficial, allow-stderr

Tests: deprecated-use
Depends: build-essential, libsdl2-dev, libsdl2-ttf-dev
Restrictions: superficial, allow-stderr

=== debian/watch ===
version=4
opts=dversionmangle=s/.dfsg\d+$//,pgpsigurlmangle=s/$/.sig/ \
  https://www.libsdl.org/release/SDL2-([\d.]+)\.tar\.(?:gz|bz2|xz|lzma)

## libsdl2 2.0.12+dfsg1

=== debian/changelog ===
libsdl2 (2.0.12+dfsg1-4) unstable; urgency=medium

  * Team upload
  * Add graphwiz to Build-Depends-Indep for the dot command.

 -- Fabian Greffrath <fabian@debian.org>  Sat, 03 Oct 2020 22:53:14 +0200

libsdl2 (2.0.12+dfsg1-3) unstable; urgency=medium

  * Team upload
  * Add libdrm-dev to Build-Depends to get the kmsdrm video driver
    working, thanks Matthew Harm Bekkema (Closes: #971529).

 -- Fabian Greffrath <fabian@debian.org>  Sat, 03 Oct 2020 22:11:05 +0200

libsdl2 (2.0.12+dfsg1-2) unstable; urgency=medium

  * Team upload

  [ Steve Langasek ]
  * use clang:native instead of clang in autopkgtests, to make
    them cross-testing friendly

  [ RALOVICH, Kristof ]
  * debian: enable kmsdrm video driver as well

 -- Fabian Greffrath <fabian@debian.org>  Tue, 18 Aug 2020 11:15:22 +0200

libsdl2 (2.0.12+dfsg1-1) unstable; urgency=medium

  * Team upload
  * Upload v2.0.12 to unstable
  * d/tests/build: Exercise compilation using clang
  * d/rules: Provide compatibility symlinks to begin_code.h, close_code.h.
    If a project that (incorrectly?) #includes <SDL2/SDL_foo.h>, such as
    jag_0.3.5-5, is compiled with gcc, our symlink to SDL_platform.h is
    sufficient to make it work. However, when compiled with clang, we need
    to provide symlinks to everything that is required by SDL_config.h,
    recursively, due to different symlink behaviour between gcc and clang.
    (This is a variation on #952066.)
  * d/tests: Exercise the #952066-like situation with clang

 -- Simon McVittie <smcv@debian.org>  Tue, 26 May 2020 14:49:00 +0100

libsdl2 (2.0.12+dfsg1-1~exp1) experimental; urgency=medium

  * Team upload

  [ Simon McVittie ]
  * New upstream release (Closes: #954660)
    - d/copyright: Update
    - d/copyright, d/gbp.conf: Exclude compiled shaders for macOS etc.
    - d/copyright, d/gbp.conf: Exclude non-free Steam Controller headers
      (these have been relicensed in the hg repository, so the exclusion
      can probably be dropped with 2.0.14, but as far as I can see they're
      only used on non-Linux platforms anyway)
  * Remove SHLIBVER, rely on debhelper compat 12 defaults

  [ Gianfranco Costamagna ]
  * Update copyright years
  * Drop CVE-2019-13616: upstream
  * Refresh no-libdir patch
  * Also install the sdl2-config-version.cmake file
  * Remove old dbgsym migration command
  * Remove signatures from signing key
  * Bump std-version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Apr 2020 14:19:49 +0100

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,15 @@
  Sam Hocevar <sho@debian.org>,
  Manuel A. Fernandez Montecelo <mafm@debian.org>,
  Felix Geyer <fgeyer@debian.org>
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Build-Depends:
  debhelper-compat (= 12),
  fcitx-libs-dev,
  libasound2-dev [linux-any],
  libdbus-1-dev,
+ libdrm-dev [linux-any],
  libegl1-mesa-dev [!hurd-any],
+ libgbm-dev [linux-any],
  libgl1-mesa-dev,
  libgles2-mesa-dev [!hurd-any],
  libglu1-mesa-dev,
@@ -39,10 +41,12 @@
  libsamplerate0-dev,
  wayland-protocols
 Build-Depends-Indep:
- doxygen <!nodoc>
+ graphviz <!nodoc>,
+ doxygen <!nodoc>,
 Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2.git
 Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2
 Homepage: https://www.libsdl.org/
+Rules-Requires-Root: no
 
 Package: libsdl2-2.0-0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -3,16 +3,15 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
-SHLIBVER = 2.0.9
-
 confflags = --disable-rpath --enable-sdl-dlopen \
             --disable-nas --disable-esd --disable-arts \
             --disable-alsa-shared --disable-pulseaudio-shared \
             --enable-ibus \
-            --enable-video-mir \
             --disable-x11-shared --disable-video-directfb \
             --enable-video-opengles \
-            --enable-video-wayland --disable-wayland-shared
+            --disable-video-opengles1 \
+            --enable-video-wayland --disable-wayland-shared \
+            --enable-video-kmsdrm --disable-kmsdrm-shared
 
 # disable autoheader (invoked automatically by autoreconf), necessary in order
 # to use debhelper compat level v10 without overriding dh-autoreconf calls
@@ -49,6 +48,8 @@
 override_dh_auto_configure:
 	dh_auto_configure -- $(confflags)
 
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+
 override_dh_auto_build-indep:
 	GZIP="-9n" tar czf debian/examples.tar.gz test --owner=0 --group=0 --mode=go=rX,u+rw,a-s --clamp-mtime --mtime="@$(SOURCE_DATE_EPOCH)" --sort=name
 	doxygen docs/doxyfile
@@ -65,6 +66,8 @@
 override_dh_installexamples-indep:
 	dh_installexamples -i --doc-main-package=libsdl2-doc
 
+endif # !nocheck
+
 override_dh_auto_build-arch:
 	dh_auto_build -- V=1
 
@@ -73,8 +76,16 @@
 	rm -f debian/examples.tar.gz
 	rm -rf output
 
+override_dh_install:
+	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2
+	mv debian/tmp/usr/include/SDL2/SDL_config.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/_real_SDL_config.h
+	ln -s ../../SDL2/SDL_platform.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/
+	ln -s ../../SDL2/begin_code.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/
+	ln -s ../../SDL2/close_code.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/
+	dh_install
+
 override_dh_missing:
-	dh_missing --fail-missing -XlibSDL2.la -XlibSDL2main.la -XlibSDL2_test.la
+	dh_missing --fail-missing
 
 override_dh_link:
 	# to address lintian warning
@@ -82,11 +93,5 @@
 	dh_link -plibsdl2-dev usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2-2.0.so.0 usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2-2.0.so
 	dh_link --remaining-packages
 
-override_dh_makeshlibs:
-	dh_makeshlibs -V"libsdl2-2.0-0 (>= $(SHLIBVER))"
-
-override_dh_strip:
-	dh_strip --dbgsym-migration='libsdl2-dbg (<< 2.0.4+dfsg2-1~)'
-
 override_dh_installchangelogs:
 	dh_installchangelogs -- WhatsNew.txt

## libsdl2 2.0.14%2Bdfsg2

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,8 @@
             --enable-video-opengles \
             --disable-video-opengles1 \
             --enable-video-wayland --disable-wayland-shared \
-            --enable-video-kmsdrm --disable-kmsdrm-shared
+            --enable-video-kmsdrm --disable-kmsdrm-shared \
+            --enable-hidapi
 
 # disable autoheader (invoked automatically by autoreconf), necessary in order
 # to use debhelper compat level v10 without overriding dh-autoreconf calls
@@ -41,24 +42,41 @@
   confflags += --disable--video-opengles
 endif
 
+# don't use libunwind even if it happens to be installed
+confflags += ac_cv_header_libunwind_h=no
 
 %:
 	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(confflags)
-
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	# test/configure.ac uses AC_PATH_X, so we need to pass in
+	# --x-includes and --x-libraries to avoid it wanting to use
+	# xmkmf to discover the right values.
+	dh_auto_configure \
+		--buildsystem=autoconf \
+		--sourcedirectory=$(CURDIR)/test \
+		--builddirectory=$(CURDIR)/debian/build-tests \
+		-- \
+		--x-includes=/usr/include \
+		--x-libraries=/usr/lib/$(DEB_HOST_MULTIARCH) \
+		SDL_CFLAGS=-I$(CURDIR)/include \
+		SDL_LIBS="-L$(CURDIR)/build/.libs -lSDL2" \
+		ac_cv_lib_SDL2_ttf_TTF_Init=no \
+		$(NULL)
 
 override_dh_auto_build-indep:
-	GZIP="-9n" tar czf debian/examples.tar.gz test --owner=0 --group=0 --mode=go=rX,u+rw,a-s --clamp-mtime --mtime="@$(SOURCE_DATE_EPOCH)" --sort=name
-	doxygen docs/doxyfile
+	GZIP="-9n" tar \
+		--exclude=autom4te.cache \
+		--owner=0 --group=0 --mode=go=rX,u+rw,a-s \
+		--clamp-mtime --mtime="@$(SOURCE_DATE_EPOCH)" \
+		--sort=name \
+		-czf debian/examples.tar.gz test
+	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile
+	cd docs && doxygen ../debian/Doxyfile
 	# useless files
-	find output -name "*.md5" -delete
-	find output -type d -empty -delete
-
-	find output -name "jquery.js" -delete
-	dh_link -plibsdl2-doc usr/share/javascript/jquery/jquery.js usr/share/doc/libsdl2-doc/html/jquery.js
+	find docs/output -name "*.md5" -delete
+	find docs/output -type d -empty -delete
 
 # Force examples to be installed in libsdl2-doc, it does not happen with compat
 # level v11 despite having the file debian/libsdl2-doc.examples (it gets
@@ -66,15 +84,30 @@
 override_dh_installexamples-indep:
 	dh_installexamples -i --doc-main-package=libsdl2-doc
 
-endif # !nocheck
-
 override_dh_auto_build-arch:
 	dh_auto_build -- V=1
+	dh_auto_build \
+		--buildsystem=autoconf \
+		--sourcedirectory=$(CURDIR)/test \
+		--builddirectory=$(CURDIR)/debian/build-tests \
+		-- \
+		V=1
 
 override_dh_auto_clean-indep:
 	dh_auto_clean
+	rm -f debian/Doxyfile
 	rm -f debian/examples.tar.gz
-	rm -rf output
+	rm -rf docs/output
+
+override_dh_auto_install-arch:
+	dh_auto_install -- V=1
+	dh_auto_install \
+		--buildsystem=autoconf \
+		--sourcedirectory=$(CURDIR)/test \
+		--builddirectory=$(CURDIR)/debian/build-tests \
+		-- \
+		installedtestsdir='/usr/lib/$(DEB_HOST_MULTIARCH)/installed-tests/SDL2' \
+		V=1
 
 override_dh_install:
 	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2
